#!/bin/awk -f
#
# MetaCheck, version 1.3
#
# metacheck - check output from metastat and generate a summary report
# regarding mirror devices with problems (failed submirrors, or too few
# submirrors)
#
# Author: Peter Erisson <pen@lysator.liu.se>, 2002-01-30
#

BEGIN { errors=0 }
/^d.*: Mirror/ { mirrorid=$1; parse=1; nmirrors=0 }
/Submirror .*: d.*/ { if (parse==1) {submirrorno=$2 ; nmirrors++; submirrorid=$3 }}
/maintenance/ { if (parse==1) {errors++; print "WARNING (needs maintenance): Mirror", mirrorid, "[ Submirror", submirrorno, submirrorid, "]" }}
/^$/ { if (parse==1 && nmirrors < 2) { print "WARNING (configuration error): Mirror", mirrorid, "contains too few submirrors" }; parse=0 }
END { if (errors > 0) {print "Total warnings: ", errors; exit errors }}
